package PaqueteJuego;

import java.util.*;
import java.util.Observable;
import java.io.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.9B54A7F0-3E2B-7E0D-1EF2-FCECB4F46E9C]
// </editor-fold> 
/**
 *
 * @author root
 */
public class Juego extends Observable {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B87E67AD-DB16-3F7D-6714-A24011022923]
    // </editor-fold> 
    private ArrayList<Jugador> Jugadores;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.704D483B-C12D-E935-D95A-9AA991D0F9F6]
    // </editor-fold> 
    private ArrayList<Carta> Cartas;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2949117A-DC96-5066-F1D6-13894EB95468]
    // </editor-fold> 
    private ArrayList<Territorio> Territorios;

    private Partida P;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CB8B4D93-9BF6-B2BB-0728-39488DDF4509]
    // </editor-fold> 
    /**
     * Constructor Juego
     */
    public Juego() {
        this.InicializaJugadores();     
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,id=DCE.C2373A94-0372-55A3-6F31-FF96C8D969F9]
    // </editor-fold> 
    /**
     *
     * @return Devuelve la lista de cartas.
     */
    public ArrayList<Carta> getCartas() {
        return this.Cartas;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.156ACEF9-2DE5-4CBC-6F4F-D1BEB4DAD620]
    // </editor-fold> 
    /**
     *
     * @param val Asigna la lista de cartas.
     */
    public void setCartas(ArrayList<Carta> val) {
        this.Cartas=val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.401CDA13-282C-908D-4264-62C482DBD4C7]
    // </editor-fold> 
    /**
     *
     * @return Devuelve la lista de territorios.
     */
    public ArrayList<Territorio> getTerritorios() {
        return this.Territorios;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.37FC5CB3-85BA-411A-2430-7BA3D5530765]
    // </editor-fold> 
    /**
     *
     * @param val Asigna la lista de territorios.
     */
    public void setTerritorios(ArrayList<Territorio> val) {
        this.Territorios=val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.7F585204-F9CD-376B-BEDD-0749594387FC]
    // </editor-fold> 
    /**
     *
     * @return Devuelve la lista de jugadores.
     */
    public ArrayList<Jugador> getJugadores() {
        return this.Jugadores;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2BABEC19-23C3-A3C0-7FD9-9006FD6404C5]
    // </editor-fold> 
    /**
     *
     * @param val Asigna la lista de jugadores.
     */
    public void setJugadores(ArrayList<Jugador> val) {
        this.Jugadores=val;
    }

    /**
     *
     * @return Devuelve la partida.
     */
    public Partida getPartida() {
        return this.P;
    }

    /**
     *
     * @param val Asigna la partida.
     */
    public void setPartida(Partida val) {
        this.P=val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.7CA6B960-7222-7074-12C6-5F9176419A2F]
    // </editor-fold> 
    /**
     * Inicializa la lista de jugadores.
     */
    public void InicializaJugadores() {
        ArrayList<Jugador> J = this.getJugadores();
        if (J==null){
                J=new ArrayList<Jugador>();
                this.setJugadores(J);
        }

    }

    /**
     * Inicializa la lista de Territorios
     * @param FicheroTerritorios Nombre del fichero de territorios desde el que se obtendran los datos
     */
    public void InicializaTerritorios(String FicheroTerritorios) {
       ArrayList<Territorio> Te = this.getTerritorios();
       String Cadena;
       int Ancho;
       int Alto;
       File archivo = null;
       FileReader fr = null;
       BufferedReader br = null;
       
         
       try{
          archivo = new java.io.File(FicheroTerritorios);

          fr = new FileReader (archivo);
          br = new BufferedReader(fr);

          if (Te==null){
            Te=new ArrayList<Territorio>();

          }else{
            Te.clear();
          }
          
          if((Cadena = br.readLine()) != null){
              Ancho=Integer.valueOf(Cadena);
          }
          if((Cadena = br.readLine()) != null){
              Alto=Integer.valueOf(Cadena);
          }
          while ((Cadena = br.readLine()) != null) {
            String[] Res;
            int Indice=4;
            ArrayList<java.lang.Integer> TV=new ArrayList<java.lang.Integer>();

            Res=Cadena.split(",");
            try{
            while(Res[Indice]!=null){
                TV.add(Integer.valueOf(Res[Indice]));
                Indice=Indice+1;
            }
            }catch(Exception E){
                
            }
            Te.add(new Territorio(Res[0],Integer.valueOf(Res[1]),0,TV,new int[]{Integer.valueOf(Res[2]),Integer.valueOf(Res[3])}));
          }
          this.setTerritorios(Te);
          fr.close();

       }catch(Exception e){
           System.out.println("No se pudo cargar la informacion de los Territorios.");
           System.out.println("El error fue : "+e.getClass().getName()+" "+e.getMessage());
           System.exit(0);

       }finally{
            try{
                if( null != fr ){
                    fr.close();
                }
            }catch (Exception e2){
            }
       }


    }

    /**
     * Inicializa la lista de Territorios
     * @param FicheroCartas Nombre del fichero de cartas desde el que se obtendran los datos
     */
    public void InicializaCartas(String FicheroCartas) {
       ArrayList<Carta> Ca = this.getCartas();
       String Cadena;
       File archivo = null;
       FileReader fr = null;
       BufferedReader br = null;
      

       try{
         
          archivo= new java.io.File(FicheroCartas);

          fr = new FileReader (archivo);
          br = new BufferedReader(fr);

           if (Ca==null){
               Ca=new ArrayList<Carta>();

           }else{
               Ca.clear();
           }

           while ((Cadena = br.readLine()) != null) {
                String[] Res;

                Res=Cadena.split(",");
                Ca.add(new Carta(Res[0],Integer.valueOf(Res[1])));
           }
           this.setCartas(Ca);
           fr.close();
           
       }catch(Exception e){
           System.out.println("No se pudo cargar la informacion de las cartas.");
           System.out.println("El error fue : "+e.getClass().getName()+" "+e.getMessage());
           System.exit(0);

       }finally{
            try{
                if( null != fr ){
                    fr.close();
                }
            }catch (Exception e2){
            }
       }

      

    }
    
    /**
     * Inicializa una partida
     * @param T Total de Turnos
     * @param SA Seleccion Aletoria
     * @param FicheroCartas Nombre del fichero de Cartas
     * @param FicheroTerritorios Nombre del fichero de Territorios
     */
    public void InicializaPartida(int TP,int T,boolean SA,String FicheroCartas,String FicheroTerritorios) {
        this.InicializaTerritorios(FicheroTerritorios);
        this.InicializaCartas(FicheroCartas);
        Partida Pa = new Partida(getTerritorios(),getJugadores(),getCartas(),T,SA,TP);
        this.setPartida(Pa);
    }

    /**
     * Finaliza la partida
     */
    public void FinalizaPartida() {
        this.setPartida(null);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.BBDD2F7E-9BD6-7FDD-21B3-C0A048C3C7DC]
    // </editor-fold> 
    /**
     * Añade un jugador
     * @param N Nombre
     * @param T Tipo Jugador
     * @param C Color Jugador
     */
    public void IncluyeJugador(String N,int T,java.awt.Color C) {
        Object O=0;
        ArrayList<Jugador> LJ = this.getJugadores();
        Jugador J=new Jugador(T,C,N);
        if(LJ.size()<6){
            LJ.add(J);
        }
        //Avisa a la ventana para que actualice los datos
        setChanged();
        notifyObservers(O);
    }

    /**
     * Crea un jugador Neutral
     */
    public void CreaJugadorNeutral(){
        IncluyeJugador("Neutral",2,java.awt.Color.GRAY);
    }

    /**
     * Elimina un jugador Neutral
     */
    public void EliminaJugadorNeutral(){
        Jugador J=null;
        Iterator<Jugador> I=getJugadores().iterator();

        while(I.hasNext()){
            J=I.next();
            if(J.getTipo()==2){
                break;
            }else{
                J=null;
            }
        }
        EliminaJugador(J);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3A0C3C02-821D-7F56-CDAD-ECCC7EC27A4B]
    // </editor-fold> 
    /**
     *
     * @param J Elimina al jugador J
     */
    public void EliminaJugador(Jugador J) {
        ArrayList<Jugador> LJ = this.getJugadores();
        if(LJ.contains(J)){
            LJ.remove(J);
        }

        //Avisa a la ventana para que actualice los datos
        setChanged();
        notifyObservers(0);
    }

    /**
     *
     * @return Devuelve el total de Jugadores
     */
    public int TotalJugadores(){
        return this.getJugadores().size();
    }

}

